<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates/framework/capdl/loader/core/src/memory.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>memory.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../capdl_loader_core/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../capdl_loader_core/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../capdl_loader_core/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">core::ops::Range</span>;

<span class="kw">use</span> <span class="ident">icecap_core::sel4::prelude</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">icecap_core::sel4::BootInfo</span>;

<span class="kw">use</span> <span class="kw">crate</span>::{<span class="ident">round_down</span>, <span class="ident">round_up</span>};

<span class="kw">extern</span> <span class="string">&quot;C&quot;</span> {
    <span class="kw">static</span> <span class="ident">__executable_start</span>: <span class="ident">u64</span>;
    <span class="kw">static</span> <span class="ident">_end</span>: <span class="ident">u64</span>;
}

<span class="attribute">#[<span class="ident">repr</span>(<span class="ident">align</span>(<span class="number">4096</span>))]</span>
<span class="kw">struct</span> <span class="ident">SmallPagePlaceHolder</span>([<span class="ident">u8</span>; <span class="ident">FrameSize::Small</span>.<span class="ident">bytes</span>()]);

<span class="kw">static</span> <span class="ident">SMALL_PAGE_PLACEHOLDER</span>: <span class="ident">SmallPagePlaceHolder</span> <span class="op">=</span>
    <span class="ident">SmallPagePlaceHolder</span>([<span class="number">0</span>; <span class="ident">FrameSize::Small</span>.<span class="ident">bytes</span>()]);

<span class="kw">fn</span> <span class="ident">addr_of_ref</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span>(<span class="ident">x</span>: <span class="kw-2">&amp;</span><span class="ident">T</span>) -&gt; <span class="ident">usize</span> {
    (<span class="ident">x</span> <span class="kw">as</span> <span class="kw-2">*const</span> <span class="ident">T</span>).<span class="ident">addr</span>()
}

<span class="kw">fn</span> <span class="ident">user_image_bounds</span>() -&gt; <span class="ident">Range</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
    <span class="kw">unsafe</span> { <span class="ident">addr_of_ref</span>(<span class="kw-2">&amp;</span><span class="ident">__executable_start</span>)..<span class="ident">addr_of_ref</span>(<span class="kw-2">&amp;</span><span class="ident">_end</span>) }
}

<span class="kw">fn</span> <span class="ident">coarsen_footprint</span>(<span class="ident">footprint</span>: <span class="ident">Range</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span>, <span class="ident">granularity</span>: <span class="ident">usize</span>) -&gt; <span class="ident">Range</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> {
    <span class="ident">round_down</span>(<span class="ident">footprint</span>.<span class="ident">start</span>, <span class="ident">granularity</span>)..<span class="ident">round_up</span>(<span class="ident">footprint</span>.<span class="ident">end</span>, <span class="ident">granularity</span>)
}

<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">init_copy_addrs</span>(<span class="ident">bootinfo</span>: <span class="kw-2">&amp;</span><span class="ident">BootInfo</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span>(<span class="ident">usize</span>, <span class="ident">usize</span>), <span class="ident">sel4::Error</span><span class="op">&gt;</span> {
    <span class="kw">let</span> <span class="ident">small_frame_copy_addr</span> <span class="op">=</span> {
        <span class="kw">let</span> <span class="ident">addr</span> <span class="op">=</span> <span class="ident">addr_of_ref</span>(<span class="kw-2">&amp;</span><span class="ident">SMALL_PAGE_PLACEHOLDER</span>);
        <span class="macro">assert_eq!</span>(<span class="ident">addr</span> <span class="op">%</span> <span class="ident">FrameSize::Small</span>.<span class="ident">bytes</span>(), <span class="number">0</span>);
        <span class="kw">let</span> <span class="ident">num_user_frames</span> <span class="op">=</span>
            <span class="ident">usize::try_from</span>(<span class="ident">bootinfo</span>.<span class="ident">user_image_frames</span>().<span class="ident">end</span> <span class="op">-</span> <span class="ident">bootinfo</span>.<span class="ident">user_image_frames</span>().<span class="ident">start</span>)
                .<span class="ident">unwrap</span>();
        <span class="kw">let</span> <span class="ident">user_image_footprint</span> <span class="op">=</span> <span class="ident">coarsen_footprint</span>(<span class="ident">user_image_bounds</span>(), <span class="ident">FrameSize::Small</span>.<span class="ident">bytes</span>());
        <span class="macro">assert_eq!</span>(
            <span class="ident">user_image_footprint</span>.<span class="ident">len</span>(),
            <span class="ident">num_user_frames</span> <span class="op">*</span> <span class="ident">FrameSize::Small</span>.<span class="ident">bytes</span>()
        );
        <span class="kw">let</span> <span class="ident">ix</span> <span class="op">=</span> (<span class="ident">addr</span> <span class="op">-</span> <span class="ident">user_image_footprint</span>.<span class="ident">start</span>) <span class="op">/</span> <span class="ident">FrameSize::Small</span>.<span class="ident">bytes</span>();
        <span class="kw">let</span> <span class="ident">cap</span> <span class="op">=</span> <span class="ident">BootInfo::init_cspace_local_cptr</span>::<span class="op">&lt;</span><span class="ident">cap_type::SmallPage</span><span class="op">&gt;</span>(
            <span class="ident">bootinfo</span>.<span class="ident">user_image_frames</span>().<span class="ident">start</span> <span class="op">+</span> <span class="ident">ix</span>,
        );
        <span class="ident">cap</span>.<span class="ident">unmap</span>()<span class="question-mark">?</span>;
        <span class="ident">addr</span>
    };
    <span class="kw">let</span> <span class="ident">large_frame_copy_addr</span> <span class="op">=</span> {
        <span class="kw">let</span> <span class="ident">addr_space_footprint</span> <span class="op">=</span> <span class="ident">coarsen_footprint</span>(
            <span class="ident">user_image_bounds</span>().<span class="ident">start</span>..<span class="ident">bootinfo</span>.<span class="ident">footprint</span>().<span class="ident">end</span>,
            <span class="ident">FrameSize::Large</span>.<span class="ident">bytes</span>(),
        );
        <span class="kw">match</span> (
            <span class="ident">addr_space_footprint</span>.<span class="ident">start</span> <span class="op">%</span> <span class="ident">FrameSize::Huge</span>.<span class="ident">bytes</span>(),
            <span class="ident">addr_space_footprint</span>.<span class="ident">end</span> <span class="op">%</span> <span class="ident">FrameSize::Huge</span>.<span class="ident">bytes</span>(),
        ) {
            (<span class="number">0</span>, <span class="number">0</span>) =&gt; <span class="macro">panic!</span>(), <span class="comment">// absurd</span>
            (<span class="kw">_</span>, <span class="number">0</span>) =&gt; {
                <span class="ident">round_down</span>(<span class="ident">addr_space_footprint</span>.<span class="ident">start</span>, <span class="ident">FrameSize::Large</span>.<span class="ident">bytes</span>())
                    <span class="op">-</span> <span class="ident">FrameSize::Large</span>.<span class="ident">bytes</span>()
            }
            (<span class="kw">_</span>, <span class="kw">_</span>) =&gt; <span class="ident">round_up</span>(<span class="ident">addr_space_footprint</span>.<span class="ident">end</span>, <span class="ident">FrameSize::Large</span>.<span class="ident">bytes</span>()),
        }
    };
    <span class="prelude-val">Ok</span>((<span class="ident">small_frame_copy_addr</span>, <span class="ident">large_frame_copy_addr</span>))
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="capdl_loader_core" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>